@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo 벻Ҫִбļ && echo. && echo 밴˳ && pause>nul && exit
set /A failure_count=0

:doCleanFactoryParam
    echo.
    echo clean-factory-param v1.0.0-2023-09-09

    for /f "tokens=2 delims=: " %%i in ('%fastboot% -s %serial_number% getvar securestate 2^>^&1^| findstr securestate') do (set securestate=%%i)

    echo.
    echo Current securestate:"%securestate%"

    if "%securestate%" NEQ "engineering" (
        echo.
        echo 豸δڹģʽ顣
        goto :endCheck
    )

    REM =============================================================
    REM Check cmdl
    set resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config cmdl 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set resp=%%i)

    if NOT %ERRORLEVEL% == 0 (
        set /A failure_count+=1
        echo WARNING: Get the cmdl failed
    )

    echo.
    echo Current cmdl:"%resp%"

    if "%resp%" NEQ "" (
        echo.
        echo ==^> Clear kernel command line.
        %fastboot% -s %serial_number% oem config cmdl ""

        if NOT %ERRORLEVEL% == 0 (
            set /A failure_count+=1
            echo WARNING: Set cmdl failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check power off mode charge
    set resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem off-mode-charge 2^>^&1 ^| findstr "off_mode_charge" ^| %%awk%% -F"off_mode_charge " "{print $2}"`) do (
        set resp=%%i
    )

    if NOT %ERRORLEVEL% == 0 (
        set /A failure_count+=1
        echo WARNING: Get the off-mode-charge status failed
    )

    echo.
    echo Current off-mode-charge status:"%resp%"

    if "%resp%"=="disabled" (
        echo.
        echo ==^> Enable off-mode-charge.
        %fastboot% -s %serial_number% oem off-mode-charge enable

        if NOT %ERRORLEVEL% == 0 (
            set /A failure_count+=1
            echo WARNING: Set off-mode-charge failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check ramdump status
    set resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem ramdump status 2^>^&1 ^| findstr "RAM dump" ^| %%awk%% -F"RAM dump " "{print $2}"`) do (
        set resp=%%i
    )

    if NOT %ERRORLEVEL% == 0 (
        set /A failure_count+=1
        echo WARNING: Get the ramdump status failed
    )

    echo.
    echo Current ramdump status:%resp%

    if "%resp%"=="enabled" (
        echo.
        echo ==^> Disable ramdump.
        %fastboot% -s %serial_number% oem ramdump disable

        %fastboot% -s %serial_number% oem ramdump disable

        if NOT %ERRORLEVEL% == 0 (
            set /A failure_count+=1
            echo WARNING: Disable ramdump failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check memtest mode
    set resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config memtest_mode 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set resp=%%i)

    if NOT %ERRORLEVEL% == 0 (
        set /A failure_count+=1
        echo WARNING: Get the memtest_mode failed
    )

    echo.
    echo Current memtest_mode:"%resp%"

    if "%resp%" NEQ "" (
        echo.
        echo ==^> Clear memtest mode.
        %fastboot% -s %serial_number% oem config memtest_mode ""

        if NOT %ERRORLEVEL% == 0 (
            set /A failure_count+=1
            echo WARNING: Set memtest_mode failed
        )
    )
    REM =============================================================

    REM =============================================================
    REM Check console param
    set resp=
    for /F "usebackq tokens=*" %%i in (`%%fastboot%% -s %%serial_number%% oem config console 2^>^&1 ^| %%sed%% "s@(bootloader)@@g;/OKAY \[/d;/^[f^|F]inished/d;/UTAG name/d;/value>/d" ^| %%awk%% "{printf \"%%s\",$0}" ^| %%sed%% "s@<descr.*@@g";`) do (set resp=%%i)

    if NOT %ERRORLEVEL% == 0 (
        set /A failure_count+=1
        echo WARNING: Get the console failed
    )

    echo.
    echo Current console:"%resp%"

    if "%resp%" NEQ "" (
        echo.
        echo ==^> Clear boot mode.
        %fastboot% -s %serial_number% oem config console ""

        if NOT %ERRORLEVEL% == 0 (
            set /A failure_count+=1
            echo WARNING: Set console failed
        )
    )
    REM =============================================================

    :endCheck
exit /b 0
