@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo 벻Ҫִбļ && echo. && echo 밴˳ && pause>nul && exit

:getPartitionTable
    REM vers
    set devicePTFile=%~dp0devicePT_%serial_number%.txt
    set device_ab_slot=0
    REM remove temp file

    del /f /s /q "%devicePTFile%" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo ش˳
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
    REM is device support A/B partition?
    set device_slot_count=0
    set device_current_slot=
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% getvar slot-count 2^>^&1 ^>nul`) do (
        for /F "tokens=2 delims== " %%C in ('echo %%X ^| %grep% "slot-count:"') do (
            set device_slot_count=%%C
        )
    )
    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% getvar current-slot 2^>^&1 ^>nul`) do (
        for /F "tokens=2 delims== " %%C in ('echo %%X ^| %grep% "current-slot:"') do (
            set device_current_slot=%%C
        )
    )

    if "%device_slot_count%" NEQ "" (
        if "!device_slot_count!" EQU "2" (
            set device_ab_slot=1
            echo.
            echo [Debug] Device [!serial_number!] has slot A/B partition.
        ) else (
            set device_ab_slot=0
            echo.
            echo [Debug] Device [!serial_number!] does not have slot A/B partition.
        )
    ) else (
        echo.
        echo [Debug] Device slot info is unknown.
        set device_ab_slot=0
    )

    set slotsuffix=
    if "%device_ab_slot%" EQU "0" (
        set slotsuffix=
    )
    if "%device_ab_slot%" EQU "1" (
        echo [Debug] Device [!serial_number!] current slot: [!device_current_slot!]
        if "!device_current_slot!" EQU "" (
            color f6
            echo [Warning] The GPT partition table is damaged. Device current slot is unknown.
            set slotsuffix=_a
        ) else (
            set slotsuffix=_!device_current_slot!
        )

        REM If there are multiple _, use the last two characters
        if "!slotsuffix:~0,2!" EQU "__" (
            set slotsuffix=!slotsuffix:~-2!
        )
    )

    %fastboot% -s %serial_number% oem partition 2>"%devicePTFile%"

    set cid_tmp=
    set sumposition=0
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "cid:" ^| %awk% "{print $2}" ^| %awk% -F: "{print $1}"') do (
        set cid_tmp=%%C
    )
    if "%cid_tmp%" EQU "lun0" (
        echo [Debug] Device [%serial_number%] has lun flag.
        set sumposition=3
    ) else (
        echo [Debug] Device [%serial_number%] does not have lun flag.
        set sumposition=2
    )

    REM QCOM device
    set fsg_count=0
    for /F "usebackq tokens=*" %%C in (`type "%%devicePTFile%%" ^| %%grep%% -i -c "fsg"`) do (
        set fsg_count=%%C
    )

    set device_is_qcom=0
    if %fsg_count% GEQ 1 (
        echo [Debug] Qualcomm device detected.
        set device_is_qcom=1
        call "%~dp0getPartitionTableQCOM.cmd"
        goto :checkGeneralPT
    )

    REM MTK device
    set tee_count=0
    for /F "usebackq tokens=*" %%C in (`type "%%devicePTFile%%" ^| %%grep%% -i -c "tee"`) do (
        set tee_count=%%C
    )

    set device_is_mtk=0
    if %tee_count% GEQ 1 (
        echo [Debug] MTK device detected.
        set device_is_mtk=1
        call "%~dp0getPartitionTableMTK.cmd"
        goto :checkGeneralPT
    )

    REM SLSI device
    set ldfw_count=0
    for /F "usebackq tokens=*" %%C in (`type "%%devicePTFile%%" ^| %%grep%% -i -c "ldfw"`) do (
        set ldfw_count=%%C
    )

    set device_is_slsi=0
    if %ldfw_count% GEQ 1 (
        echo [Debug] SLSI device detected.
        set device_is_slsi=1
        call "%~dp0getPartitionTableSLSI.cmd"
        goto :checkGeneralPT
    )

    echo.
    echo [ERROR] Unable to identify device type, please contact the developer.
    exit /b 1

    :checkGeneralPT
    REM general partitions
    set init_boot_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "init_boot%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set init_boot_a_tmp=%%C
    )
    set vendor_boot_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "vendor_boot%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set vendor_boot_a_tmp=%%C
    )
    set recovery_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "recovery%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set recovery_a_tmp=%%C
    )
    set pvmfw_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "pvmfw%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set pvmfw_a_tmp=%%C
    )
    set dtb_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "dtb%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set dtb_a_tmp=%%C
    )
    set dtbo_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "dtbo%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set dtbo_a_tmp=%%C
    )
    set vbmeta_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "vbmeta%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set vbmeta_a_tmp=%%C
    )
    set vbmeta_system_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "vbmeta_system%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set vbmeta_system_a_tmp=%%C
    )
    set super_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "super:" ^| %awk% "{print $%sumposition%}"') do (
        set super_tmp=%%C
    )
    set system_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "system%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set system_a_tmp=%%C
    )
    set vendor_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "vendor%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set vendor_a_tmp=%%C
    )
    set product_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "product%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set product_a_tmp=%%C
    )
    set oem_a_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "oem%slotsuffix%:" ^| %awk% "{print $%sumposition%}"') do (
        set oem_a_tmp=%%C
    )
    set carrier_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "carrier:" ^| %awk% "{print $%sumposition%}"') do (
        set carrier_tmp=%%C
    )
    set cache_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "cache:" ^| %awk% "{print $%sumposition%}"') do (
        set cache_tmp=%%C
    )
    set customize_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "customize:" ^| %awk% "{print $%sumposition%}"') do (
        set customize_tmp=%%C
    )
    set clogo_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "clogo:" ^| %awk% "{print $%sumposition%}"') do (
        set clogo_tmp=%%C
    )
    set metadata_tmp=
    for /F %%C in ('type "%devicePTFile%" ^| %grep% "metadata:" ^| %awk% "{print $%sumposition%}"') do (
        set metadata_tmp=%%C
    )

    set device_has_init_boot=0
    if "%init_boot_a_tmp%" EQU "init_boot%slotsuffix%:" (
        set device_has_init_boot=1
    )
    set device_has_vendor_boot=0
    if "%vendor_boot_a_tmp%" EQU "vendor_boot%slotsuffix%:" (
        set device_has_vendor_boot=1
    )
    set device_has_recovery=0
    if "%recovery_a_tmp%" EQU "recovery%slotsuffix%:" (
        set device_has_recovery=1
    )
    set device_has_pvmfw=0
    if "%pvmfw_a_tmp%" EQU "pvmfw%slotsuffix%:" (
        set device_has_pvmfw=1
    )
    set device_has_dtb=0
    if "%dtb_a_tmp%" EQU "dtb%slotsuffix%:" (
        set device_has_dtb=1
    )
    set device_has_dtbo=0
    if "%dtbo_a_tmp%" EQU "dtbo%slotsuffix%:" (
        set device_has_dtbo=1
    )
    set device_has_vbmeta=0
    if "%vbmeta_a_tmp%" EQU "vbmeta%slotsuffix%:" (
        set device_has_vbmeta=1
    )
    set device_has_vbmeta_system=0
    if "%vbmeta_system_a_tmp%" EQU "vbmeta_system%slotsuffix%:" (
        set device_has_vbmeta_system=1
    )
    set device_has_super=0
    if "%super_tmp%" EQU "super:" (
        set device_has_super=1
    )
    set device_has_system=0
    if "%system_a_tmp%" EQU "system%slotsuffix%:" (
        set device_has_system=1
    )
    set device_has_vendor=0
    if "%vendor_a_tmp%" EQU "vendor%slotsuffix%:" (
        set device_has_vendor=1
    )
    set device_has_product=0
    if "%product_a_tmp%" EQU "product%slotsuffix%:" (
        set device_has_product=1
    )
    set device_has_oem=0
    if "%oem_a_tmp%" EQU "oem%slotsuffix%:" (
        set device_has_oem=1
    )
    set device_has_carrier=0
    if "%carrier_tmp%" EQU "carrier:" (
        set device_has_carrier=1
    )
    set device_has_cache=0
    if "%cache_tmp%" EQU "cache:" (
        set device_has_cache=1
    )
    set device_has_customize=0
    if "%customize_tmp%" EQU "customize:" (
        set device_has_customize=1
    )
    set device_has_clogo=0
    if "%clogo_tmp%" EQU "clogo:" (
        set device_has_clogo=1
    )
    set device_has_metameta=0
    if "%metadata_tmp%" EQU "metadata:" (
        set device_has_metameta=1
    )

    REM remove temp file
    del /f /s /q "%devicePTFile%" >nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo ش˳
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )
exit /b 0
::
::
:exit
exit
